UNIT mTMergeSort;

interface

//--------------------  ggf Uses-Liste anpassen !  --------------------
uses mTSortiermaschine;

type
   TMergeSort = CLASS(TSortiermaschine)

     // weitere Methoden
     private
        procedure merge(unten,oben:longint);
        procedure mischen(unten,mitte,oben:longint);
     public
        procedure sortiereZufallsfeld; override;

   end;

implementation

//+---------------------------------------------------------------------
//|         TMergeSort: Methodendefinition 
//+---------------------------------------------------------------------

//-------- merge (private) ---------------------------------------------
procedure TMergeSort.merge(unten,oben:longint);
begin
  //??????????????????????????????????
end;

//-------- mischen (private) -------------------------------------------
procedure TMergeSort.mischen(unten,mitte,oben:longint);
var dummy        : TFeld;
    j,i,k,s,ir,l : longint;
Begin
  j:=mitte+1;
  i:=unten;
  k:=unten;
  while (i<=mitte) and (j<=oben) do
  begin
    if (zufallsfeld[i] <= zufallsfeld[j])
    then
    begin
      dummy[k]:=zufallsfeld[i];
      i:=i+1;
    end
    else
    begin
      dummy[k]:=zufallsfeld[j];
      j:=j+1;
    end;
    k:=k+1
  end;
  if i>mitte
  then for s:=j to oben do dummy[k+s-j]:=zufallsfeld[s]
  else for ir:=i to mitte do dummy[k+ir-i]:=zufallsfeld[ir];
  for l:=unten to oben do zufallsfeld[l]:=dummy[l];
end;

//-------- sortiereZufallsfeld (public) --------------------------------
procedure TMergeSort.sortiereZufallsfeld;
begin
  self.merge(untereGrenze,obereGrenze);
end;

end.
