UNIT mTSortiermaschine;

interface

//Abstrakte Klasse!
//--------------------  ggf Uses-Liste einfgen !  --------------------

type
   tfeld=Array [0..100000] of longint;

type
   TSortiermaschine = CLASS

     // weitere Attribute
     protected
         Zufallsfeldlaenge : integer;
         obereGrenze : Longint;
         untereGrenze : Longint;
         Zufallsfeld : tfeld;

     // weitere Methoden

        procedure tausche(var a,b:longint);
     public
        constructor init;
        procedure SetzeGrenzen(pUntereGrenze,pObereGrenze:Longint);
        procedure SetzeZufallsfeld(pZufallsfeld:array of longint);
        procedure SetzeZufallsfeldlaenge(pZufallsfeldlaenge:integer);
        procedure sortiereZufallsfeld; virtual; abstract;
        function GibZufallsfeld : tfeld;
        destructor gibfrei;

   end;

implementation

//+---------------------------------------------------------------------
//|         TSortiermaschine: Methodendefinition 
//+---------------------------------------------------------------------

//-------- tausche (private) -------------------------------------------
procedure TSortiermaschine.tausche(var a,b:longint);
var
  x:Longint;
begin
  x:=a;
  a:=b;
  b:=x;
end;

//-------- init (public) -----------------------------------------------
constructor TSortiermaschine.init;
begin
  inherited create;
  zufallsfeldlaenge:=1;
end;

//-------- SetzeGrenzen (public) ---------------------------------------
procedure TSortiermaschine.SetzeGrenzen(pUntereGrenze,pObereGrenze:Longint);
   begin
      untereGrenze := pUntereGrenze;
      obereGrenze := pObereGrenze;
   end;

//-------- SetzeZufallsfeld (public) -----------------------------------
procedure TSortiermaschine.SetzeZufallsfeld(pZufallsfeld:array of longint);
var i:longint;
begin
  for i:=0 to zufallsfeldlaenge-1 do zufallsfeld[i]:=pzufallsfeld[i];
end;

//-------- SetzeZufallsfeldlaenge (public) -----------------------------
procedure TSortiermaschine.SetzeZufallsfeldlaenge(pZufallsfeldlaenge:integer);
begin
  Zufallsfeldlaenge := pZufallsfeldlaenge;
end;

//-------- GibZufallsfeld (public) -------------------------------------
function TSortiermaschine.GibZufallsfeld : tfeld;
var i:longint;
begin
  for i:=0 to zufallsfeldlaenge-1 do result[i]  := Zufallsfeld[i]
end;

//-------- gibfrei (public) --------------------------------------------
destructor TSortiermaschine.gibfrei;
begin
  inherited destroy;
end;

end.
