UNIT mTZufallsfelderzeuger;

interface


//--------------------  ggf Uses-Liste einfgen !  --------------------


type tfeld=array [0..100000] of longint;

type
   TZufallsfelderzeuger = CLASS

     // weitere Attribute
     private
        zufallsfeldlaenge : longint;
        Zufallsfeld : tfeld;
        procedure tausche(var a,b:Longint);
     // weitere Methoden
     public
        constructor init;
        procedure erzeugeZufallsfeld;
        procedure SetzeZufallsfeldlaenge(pZufallsfeldlaenge:longint);
        function GibZufallsfeld : tfeld;
        function GibZufallsfeldlaenge : longint;
        destructor gibfrei;

   end;

implementation

//+---------------------------------------------------------------------
//|         TZufallsfelderzeuger: Methodendefinition 
//+---------------------------------------------------------------------

//-------- init (public) -----------------------------------------------
constructor TZufallsfelderzeuger.init;
begin
  inherited create;
  randomize;
  zufallsfeldlaenge:=1;
end;

procedure Tzufallsfelderzeuger.tausche(var a,b:Longint);
var
  x:Longint;
begin
  x:=a;
  a:=b;
  b:=x;
end;

//-------- erzeugeZufallsfeld (public) ---------------------------------
procedure TZufallsfelderzeuger.erzeugeZufallsfeld;
var
  i:longint;
begin
  //Erzeugen eines geordneten Feldes
  for i:=0 to zufallsfeldlaenge-1 do Zufallsfeld[i]:=i+1;
  //Zahlen durcheinanderwirbeln
  for i:=0 to zufallsfeldlaenge-1 do tausche(Zufallsfeld[i],Zufallsfeld[random(zufallsfeldlaenge)]);
end;

//-------- SetzeZufallsfeldlaenge (public) -----------------------------
procedure TZufallsfelderzeuger.SetzeZufallsfeldlaenge(pZufallsfeldlaenge:longint);
begin
  zufallsfeldlaenge := pZufallsfeldlaenge
end;

//-------- GibZufallsfeld (public) -------------------------------------
function TZufallsfelderzeuger.GibZufallsfeld : tfeld;
begin
  result  := Zufallsfeld
end;

//-------- GibZufallsfeldlaenge (public) -------------------------------
function TZufallsfelderzeuger.GibZufallsfeldlaenge : longint;
begin
  result  := zufallsfeldlaenge
end;

//-------- gibfrei (public) --------------------------------------------
destructor TZufallsfelderzeuger.gibfrei;
begin
  inherited destroy;
end;

end.
